<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Christian Stocker <chregu@bitflux.ch>                        |
// +----------------------------------------------------------------------+
//
// $Id: aggregator.php,v 1.5 2003/07/14 17:09:46 glandium Exp $

include_once(PAPAAN_BASE.'/components/component.php');

/**
* Class for aggregating content
*
* @author   Christian Stocker <chregu@bitflux.ch>
* @version  $Id: aggregator.php,v 1.5 2003/07/14 17:09:46 glandium Exp $
* @package  papaan
*/
class aggregator extends component {
	var $xml = '';

	function aggregator(&$sitemap) {
		$this->sitemap = &$sitemap;
	}
	
	/**
    * Initiator, called after construction of object
    *
    *  This method will be called in the start element with the attributes from this element
    *
    *  @param $attribs array	associative array with element attributes
    *  @access public
	*/
    function init($attribs) {
    	parent::init($attribs);
		
		$rootElement = $this->getAttrib('element');
		$rootNs = $this->getAttrib('ns');
		$rootPrefix = $this->getAttrib('prefix');
		$this->xml = domxml_new_doc('1.0');
		if ($rootNs) {
			$this->xmlRoot = $this->xml->append_child($this->xml->create_element_ns($rootNs,$rootElement,$rootPrefix));
		} else {
			$this->xmlRoot = $this->xml->new_child($rootElement);
		}
	}
	
	function start(&$xml) {
		$xml = $this->xml;
	}
	
	function addPart($attribs) {
		if (isset($attribs['strip-root'])) {
			$stripRoot = $attribs['strip-root'];
		} else {
	    		$stripRoot = false;
		}

		$xmldoc = $this->readfile($attribs['src']);
		$this->sitemap->var2XMLObject($xmldoc);
		$root = $xmldoc->document_element();
		if ($stripRoot == 'true') {
			$children = $root->child_nodes();
			foreach ($children as $child) {
				$this->xmlRoot->append_child($child->clone_node(true));
			}
		} else {
			$this->xmlRoot->append_child($root->clone_node(true));
		}
	}
}
