<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Christian Stocker <chregu@bitflux.ch>                        |
// +----------------------------------------------------------------------+
//
// $Id: selector.php,v 1.5 2003/07/09 19:32:48 glandium Exp $

/**
* This is the Base-Class for all selectors
*
* Selectors are used in <map:select> in sitemap.xml
*
*  Selectors match here much the same as Matchers, this is different to cocoon
*   they don't return the hits, but nevermind :)
*
* @author   Christian Stocker <chregu@bitflux.ch>
* @version  $Id: selector.php,v 1.5 2003/07/09 19:32:48 glandium Exp $
* @package  papaan
* @module	selectors
*/
class selector {
	var $debug = False;
	var $hit = False;

	function selector(&$sitemap, $config) {
		$this->sitemap = &$sitemap;
		$this->config = $config;
	}

	function init($attribs)
    {
	    $this->attribs = $attribs;
        $debug = $this->getAttrib('debug');
        if (!is_null($debug) && $debug!='no'  )
        {
        	$this->debug = True;
            $GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = '---';
            $GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = 'selector:'.get_class($this);

            foreach ($this->attribs as $key => $value)
            {
            	$GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = "$key => $value";
            }
			$GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = '---';
		}
    }
    
	function test() {
	}

    
    function getAttrib($attribute) {
	    if (isset($this->attribs[$attribute]))
        {
//			return $this->attribs[$attribute] = $this->attribs[$attribute];
			return $this->attribs[$attribute];
			
		}
        else
        {
        	return Null;
		}
	}

	function setParameter($key,$value) 
	{
		if (!isset($this->params))
		{
			$this->params = array();
		}
		$this->params[$key]=$value;
	}
		
	function getParameter($key = false) {
		if ($key) 
		{
			if (isset($this->params[$key])) 
			{
				return $this->params[$key];
			}
			else
			{
				return null;
			}
		}
		else
		{		
			if (isset($this->params)) {
				$retarr = array();
				foreach ($this->params as $value => $key) 
				{
					$retarr[$value] = $key;
				}
				return $retarr;
			} 
			else 
			{
				return array();
			}
		}
	}

    /**
    * Adds an entry to the debug Output
    *  if $this->debug is true
    *
    * @param  mixed  content  text to be added
    * @access private
    */
    function printDebug($content)
    {
		if ($this->debug)
        {
			$GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = $content;
    	}
    }

    /**
    * Adds an decomposed Array to the debug Output
    *  if $this->debug is true
    *
    * @param  array array Array to be added
    * @param  string description line to be added before array
    * @access private
    */    
    function printDebugArray($array,$description = '')
    {
		if ($this->debug)
        {
			$GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = $description;
        	foreach($array as $key => $value)
            {
				$GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = "$key => $value";
			}
    	}
    }
    
}
