<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Christian Stocker <chregu@bitflux.ch>                        |
// +----------------------------------------------------------------------+
//
// $Id: xml.php,v 1.10 2003/07/12 14:44:16 glandium Exp $

include_once(PAPAAN_BASE . '/components/serializer.php');

/**
* Outputs the XML-Document as XML
*
* @author   Christian Stocker <chregu@bitflux.ch>
* @version  $Id: xml.php,v 1.10 2003/07/12 14:44:16 glandium Exp $
* @package  papaan
*/
class serializer_xml extends serializer {

	/* Default encoding output is UTF-8 */
	var $encoding = 'UTF-8';
    
	function serializer_xml (&$sitemap, $config) {
		$this->serializer($sitemap, $config);
    	// Quick and dirty way ; should check more cleanly if there's no garbage in configuration
	if (isset($this->config['dom'])) {
		$xpath = xpath_new_context($this->config['dom']);
		$xnode = xpath_eval($xpath,'/config/encoding');
		if (count($xnode->nodeset)) {
			$encoding = $xnode->nodeset[0]->get_content();
			if ($encoding) {
				$this->encoding = $encoding;
			}
		}
		$xnode = xpath_eval($xpath,'/config/doctype-system');
		if (count($xnode->nodeset)) {
			$doctype_system = $xnode->nodeset[0]->get_content();
			if ($doctype_system) {
				$this->doctype_system = $doctype_system;
			}
		}
		$xnode = xpath_eval($xpath,'/config/doctype-public');
		if (count($xnode->nodeset)) {
			$doctype_public = $xnode->nodeset[0]->get_content();
			if ($doctype_public) {
				$this->doctype_public = $doctype_public;
			}
		}
	}
	if (isset($this->config['mime-type'])) {
        	$this->sitemap->setContentType($this->config['mime-type'].'; charset='.$this->encoding);
	} else {
        	$this->sitemap->setContentType('text/xml');
	}
    }
	
    function DomStart(&$xml)
    {
        parent::DomStart($xml);
	$this->sitemap->hasFinalDom = true;
	$root = $xml->document_element();
	$dtd = $xml->doctype();
	if ($dtd) {
		$dtd->unlink();
	}
	$tmp = $xml->dumpmem(0,$this->encoding);
	if (isset($this->doctype_system)) {
		/* Assume we have an XML declaration */
		$list = preg_split('/\?>/',$tmp, 2);
		$declaration = $list[0];
		if (count($list) == 2) {
			$content = $list[1];
		}
		print $declaration."?>\n";
		if (isset($this->doctype_public)) {
			print '<!DOCTYPE '.$root->node_name().' PUBLIC "'.$this->doctype_public.'" "'.$this->doctype_system.'">';
		} else {
			print '<!DOCTYPE '.$root->node_name().' SYSTEM "'.$this->doctype_system.'">';
		}
		print $content;
	} else {
		print $tmp;
	}
    }
}


?>
